package ch.hepia.tpscala.monoid

import org.scalatest.funsuite.AnyFunSuite

import Examples._

class Monoid8Suite extends AnyFunSuite {


  test( "minMax" ) {
    assert( minMax( List(1,2,3,4,5,6) ) == (1,6)  )
    assert( minMax( List(1) ) == (1,1)  )
    assert( minMax( List(2,2,2,2,2,2,2,2) ) == (2,2) )
    assert( minMax( List(100,-100) ) == (-100, 100) )
  }

  test( "and" ) {
    assert( and(Nil) && and(List(true)) == true )
    assert( and(List( true, true, true ))  == true )
    assert( and(List( true, true, false ))  == false )
  }

  test( "even" ) {
    assert( even( Nil ) == true )
    assert( even( List(0) ) == false )
    assert( even( List(0,0) ) == true )
    assert( even( List(0,0,0) ) == false )
    assert( even( List(0,0,0,0) ) == true )
    assert( even( List(0,0,0,0,0) ) == false )
  }


  test( "count" ) {
    assert( count( List("y", "n", "y", "y", "n", "y") ) == Map( "y"->4, "n"->2 ) )
    assert( count(Nil) == Map() )
    assert( count( List(1,2,3,4,5) ) == Map( 1->1, 2->1, 3->1, 4->1, 5->1 ) )
  }

  test( "count2" ) {
    assert(
      count2( List( ("a","y"), ("a", "y"), ("b","y"), ("b","n"), ("c","y") ) ) ==
        Map(
          "a" -> Map("y"->2),
          "b" -> Map ("y"->1, "n"->1),
          "c" -> Map("y"->1 )
        )
    )     
  }

  test( "forall" ) {
    val big = (_:Int) >= 100
    val even = (_:Int) % 2 == 0
    val mul3 = (_:Int ) % 3 == 0
    val ps = forall( List( big, even, mul3 ) )
    assert( ps( 402 ) )
    assert( ! ps( 200 ) )
    assert( forall( Nil )( 402 ) )
    assert( forall( Nil )( 200 ) )
  }

  /*test("sort") {
    val test1 = List(2.0,1.0,5.0,6.0,4.0,8.0,7.0,1.0)
    assert(sort(test1) == List(1.0,1.0,2.0,4.0,5.0,6.0,7.0,8.0))
  }*/



}
